unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Timer1: TTimer;
    procedure Timer1Timer(Sender: TObject);
  private
    procedure Doit();
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//-----------------------------------------------------------------------------
//  EBhẼNXo
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html
function GetClassNameStr(Handle:HWND):string;
var
  Len:integer;
  PC:PChar;
begin
  GetMem(PC,100);
  Len := GetClassName(Handle,PC,100);
  SetString(result,PC,Len);
  FreeMem(PC);
end;

//-----------------------------------------------------------------------------
//  EBhẼeLXgo
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html
function GetWindowTextStr(hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  ret := GetWindowTextLength(hWindow);
  GetMem(p,ret+1);
  ret := GetWindowText(hWindow,p,ret+1);
  SetString(result,p,ret);
  FreeMem(p);
end;

type
  PHWndArray = ^THWndArray;
  THWndArray = array[0..500] of HWND;

//-----------------------------------------------------------------------------
//  ŏĩEBhE擾
function GetMostTopLevelWindow(hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;

//-----------------------------------------------------------------------------
//  j[񋓂
function EnumMenuWindow(var WA: THWndArray):integer;
var
  hWindow:HWND;
  ClsName: string;
begin
  WA[0] := 0;
  hWindow := GetWindow(Application.Handle,GW_HWNDFIRST);
  while (hWindow <> 0) do
  begin
    ClsName := GetClassNameStr(hWindow);
    if ClsName = '#32768' then
    begin
      WA[0] := WA[0]+1;
      WA[WA[0]] := hWindow
    end;
    hWindow := GetWindow(hWindow,GW_HWNDNEXT);
  end;
  result := WA[0];
end;

//  ---------------------------------------------------------------------------
//  w肵nhEBhẺ`悷
procedure FlashDesktopCanvas(const Target: HWND; const Interval: integer);
var
    DesktopDC: HDC;
    RT: TRect;
    WI: TWindowInfo;
    DesktopCanvas: TCanvas;
begin
    //  fXNgbṽfoCXReLXg擾
    DesktopDC := GetDC(0);
    if (DesktopDC <> INVALID_HANDLE_VALUE) then
    begin
        DesktopCanvas := TCanvas.Create;
        try
            //  O
            DesktopCanvas.Handle := DesktopDC;
            DesktopCanvas.Pen.Width := 3;
            DesktopCanvas.Pen.Mode := pmNotXor;
            //  EBhE擾
            if GetWindowInfo(Target, WI) then
            begin
                //  NCAg̈擾
                RT := WI.rcWindow;
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
                //  ΂҂
                Sleep(Interval);
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
            end;
        finally
            //  fXNgbṽfoCXReLXgj
            DesktopCanvas.Free;
            ReleaseDC(0, DesktopDC);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  Ď
procedure TForm1.Doit();
var
  WA:THWndArray;
  i,Num:integer;
begin
  ListBox1.Clear;
  Num := EnumMenuWindow(WA);
  if Num > 0 then
  begin
    for i := 1 to Num do
    begin
      //  Xgɗ
      ListBox1.Items.Add(
        Format('$%.8x (%d) [%s/%s] in [%s/%s]', [
          WA[i],WA[i],
          GetClassNameStr(WA[i]),
          GetWindowTextStr(WA[i]),
          GetClassNameStr(GetMostTopLevelWindow(WA[i])),
          GetWindowTextStr(GetMostTopLevelWindow(WA[i]))
        ])
      );
      //  _ł
      FlashDesktopCanvas(WA[i], 50);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  ^C}[
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Doit();
end;

end.
